/**
 * OSDN REST API v0 beta
 * OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 . 
 *
 * OpenAPI spec version: 0.0.20161031
 * Contact: admin@osdn.net
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['OSDN/ApiClient', 'OSDN/OSDN\Model/ModelPackage', 'OSDN/OSDN\Model/ProjectBzr', 'OSDN/OSDN\Model/ProjectGit', 'OSDN/OSDN\Model/ScmHook', 'OSDN/OSDN\Model/ProjectHg', 'OSDN/OSDN\Model/Release', 'OSDN/OSDN\Model/RelFile', 'OSDN/OSDN\Model/News', 'OSDN/OSDN\Model/Group', 'OSDN/OSDN\Model/ProjectWeb', 'OSDN/OSDN\Model/GroupProfile', 'OSDN/OSDN\Model/ProjectSvn', 'OSDN/OSDN\Model/GroupToolFlags'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('../OSDN\Model/ModelPackage'), require('../OSDN\Model/ProjectBzr'), require('../OSDN\Model/ProjectGit'), require('../OSDN\Model/ScmHook'), require('../OSDN\Model/ProjectHg'), require('../OSDN\Model/Release'), require('../OSDN\Model/RelFile'), require('../OSDN\Model/News'), require('../OSDN\Model/Group'), require('../OSDN\Model/ProjectWeb'), require('../OSDN\Model/GroupProfile'), require('../OSDN\Model/ProjectSvn'), require('../OSDN\Model/GroupToolFlags'));
  } else {
    // Browser globals (root is window)
    if (!root.OSDNClient) {
      root.OSDNClient = {};
    }
    root.OSDNClient.ProjectApi = factory(root.OSDNClient.ApiClient, root.OSDNClient.ModelPackage, root.OSDNClient.ProjectBzr, root.OSDNClient.ProjectGit, root.OSDNClient.ScmHook, root.OSDNClient.ProjectHg, root.OSDNClient.Release, root.OSDNClient.RelFile, root.OSDNClient.News, root.OSDNClient.Group, root.OSDNClient.ProjectWeb, root.OSDNClient.GroupProfile, root.OSDNClient.ProjectSvn, root.OSDNClient.GroupToolFlags);
  }
}(this, function(ApiClient, ModelPackage, ProjectBzr, ProjectGit, ScmHook, ProjectHg, Release, RelFile, News, Group, ProjectWeb, GroupProfile, ProjectSvn, GroupToolFlags) {
  'use strict';

  /**
   * Project service.
   * @module OSDN/OSDN\Api/ProjectApi
   * @version 0.0.20161031
   */

  /**
   * Constructs a new ProjectApi. 
   * @alias module:OSDN/OSDN\Api/ProjectApi
   * @class
   * @param {module:OSDN/ApiClient} apiClient Optional API client implementation to use,
   * default to {@link module:OSDN/ApiClient#instance} if unspecified.
   */
  var exports = function(apiClient) {
    this.apiClient = apiClient || ApiClient.instance;


    /**
     * Callback function to receive the result of the createNews operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createNewsCallback
     * @param {String} error Error message, if any.
     * @param {'String'} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} title news title
     * @param {String} body news body in OSDN Wiki format.
     * @param {Integer} groupId group_id the news created in
     * @param {module:OSDN/OSDN\Api/ProjectApi~createNewsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {'String'}
     */
    this.createNews = function(title, body, groupId, callback) {
      var postBody = null;

      // verify the required parameter 'title' is set
      if (title == undefined || title == null) {
        throw "Missing the required parameter 'title' when calling createNews";
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw "Missing the required parameter 'body' when calling createNews";
      }

      // verify the required parameter 'groupId' is set
      if (groupId == undefined || groupId == null) {
        throw "Missing the required parameter 'groupId' when calling createNews";
      }


      var pathParams = {
      };
      var queryParams = {
        'group_id': groupId
      };
      var headerParams = {
      };
      var formParams = {
        'title': title,
        'body': body
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = 'String';

      return this.apiClient.callApi(
        '/news', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createNews_0 operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createNews_0Callback
     * @param {String} error Error message, if any.
     * @param {'String'} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} idOrName numeric project id or project name
     * @param {String} title news title
     * @param {String} body news body in OSDN Wiki format.
     * @param {module:OSDN/OSDN\Api/ProjectApi~createNews_0Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {'String'}
     */
    this.createNews_0 = function(idOrName, title, body, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createNews_0";
      }

      // verify the required parameter 'title' is set
      if (title == undefined || title == null) {
        throw "Missing the required parameter 'title' when calling createNews_0";
      }

      // verify the required parameter 'body' is set
      if (body == undefined || body == null) {
        throw "Missing the required parameter 'body' when calling createNews_0";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'title': title,
        'body': body
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = 'String';

      return this.apiClient.callApi(
        '/project/{id_or_name}/news', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createPackage operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createPackageCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ModelPackage} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a package.
     * @param {String} idOrName numeric project id or project name
     * @param {String} name package name
     * @param {Object} opts Optional parameters
     * @param {String} opts.visibility visibility status (public, hidden or private)
     * @param {module:OSDN/OSDN\Api/ProjectApi~createPackageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ModelPackage}
     */
    this.createPackage = function(idOrName, name, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createPackage";
      }

      // verify the required parameter 'name' is set
      if (name == undefined || name == null) {
        throw "Missing the required parameter 'name' when calling createPackage";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'name': name,
        'visibility': opts['visibility']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ModelPackage;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createProjectBzr operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createProjectBzrCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectBzr} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new bzr repository
     * @param {String} idOrName numeric project id or project name
     * @param {String} name 
     * @param {Object} opts Optional parameters
     * @param {String} opts.description 
     * @param {module:OSDN/OSDN\Api/ProjectApi~createProjectBzrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectBzr}
     */
    this.createProjectBzr = function(idOrName, name, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createProjectBzr";
      }

      // verify the required parameter 'name' is set
      if (name == undefined || name == null) {
        throw "Missing the required parameter 'name' when calling createProjectBzr";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'name': name,
        'description': opts['description']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectBzr;

      return this.apiClient.callApi(
        '/project/{id_or_name}/bzr', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createProjectGit operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createProjectGitCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectGit} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new git repository
     * @param {String} idOrName numeric project id or project name
     * @param {String} name 
     * @param {Object} opts Optional parameters
     * @param {String} opts.description 
     * @param {Boolean} opts.mailEnabled 
     * @param {String} opts.mailRecipients 
     * @param {Boolean} opts.allowNonFastForward 
     * @param {module:OSDN/OSDN\Api/ProjectApi~createProjectGitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectGit}
     */
    this.createProjectGit = function(idOrName, name, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createProjectGit";
      }

      // verify the required parameter 'name' is set
      if (name == undefined || name == null) {
        throw "Missing the required parameter 'name' when calling createProjectGit";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'name': name,
        'description': opts['description'],
        'mail_enabled': opts['mailEnabled'],
        'mail_recipients': opts['mailRecipients'],
        'allow_non_fast_forward': opts['allowNonFastForward']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectGit;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createProjectGitHook operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createProjectGitHookCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ScmHook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new hook for project git repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {String} targetUrl 
     * @param {module:OSDN/OSDN\Api/ProjectApi~createProjectGitHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ScmHook}
     */
    this.createProjectGitHook = function(idOrName, repoId, targetUrl, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createProjectGitHook";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling createProjectGitHook";
      }

      // verify the required parameter 'targetUrl' is set
      if (targetUrl == undefined || targetUrl == null) {
        throw "Missing the required parameter 'targetUrl' when calling createProjectGitHook";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'target_url': targetUrl
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ScmHook;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}/hooks', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createProjectHg operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createProjectHgCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectHg} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create a new hg repository
     * @param {String} idOrName numeric project id or project name
     * @param {String} name 
     * @param {Object} opts Optional parameters
     * @param {String} opts.description 
     * @param {String} opts.mailRecipients 
     * @param {module:OSDN/OSDN\Api/ProjectApi~createProjectHgCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectHg}
     */
    this.createProjectHg = function(idOrName, name, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createProjectHg";
      }

      // verify the required parameter 'name' is set
      if (name == undefined || name == null) {
        throw "Missing the required parameter 'name' when calling createProjectHg";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'name': name,
        'description': opts['description'],
        'mail_recipients': opts['mailRecipients']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectHg;

      return this.apiClient.callApi(
        '/project/{id_or_name}/hg', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createRelease operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createReleaseCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/Release} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new release in specified package.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {String} name Release name
     * @param {Object} opts Optional parameters
     * @param {String} opts.visibility visibility status (public, hidden or private)
     * @param {Date} opts.time Release datetime. If you set future time, the release hide until specified time.
     * @param {String} opts.releaseNote Release note body text.
     * @param {String} opts.changeLog Changelog body text.
     * @param {module:OSDN/OSDN\Api/ProjectApi~createReleaseCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/Release}
     */
    this.createRelease = function(idOrName, packageId, name, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createRelease";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling createRelease";
      }

      // verify the required parameter 'name' is set
      if (name == undefined || name == null) {
        throw "Missing the required parameter 'name' when calling createRelease";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'visibility': opts['visibility'],
        'name': name,
        'time': opts['time'],
        'release_note': opts['releaseNote'],
        'change_log': opts['changeLog']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = Release;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the createReleaseFile operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~createReleaseFileCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/RelFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Create new file in target release.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {File} file Upload file in \&quot;multipart/form-data\&quot;.
     * @param {Object} opts Optional parameters
     * @param {String} opts.visibility visibility status (public, hidden or private)
     * @param {module:OSDN/OSDN\Api/ProjectApi~createReleaseFileCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/RelFile}
     */
    this.createReleaseFile = function(idOrName, packageId, releaseId, file, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling createReleaseFile";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling createReleaseFile";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling createReleaseFile";
      }

      // verify the required parameter 'file' is set
      if (file == undefined || file == null) {
        throw "Missing the required parameter 'file' when calling createReleaseFile";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'visibility': opts['visibility'],
        'file': file
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['multipart/form-data'];
      var accepts = [];
      var returnType = RelFile;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}', 'POST',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteNews operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~deleteNewsCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {Integer} newsId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~deleteNewsCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteNews = function(newsId, callback) {
      var postBody = null;

      // verify the required parameter 'newsId' is set
      if (newsId == undefined || newsId == null) {
        throw "Missing the required parameter 'newsId' when calling deleteNews";
      }


      var pathParams = {
        'news_id': newsId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = null;

      return this.apiClient.callApi(
        '/news/{news_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteNews_0 operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~deleteNews_0Callback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} newsId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~deleteNews_0Callback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteNews_0 = function(idOrName, newsId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling deleteNews_0";
      }

      // verify the required parameter 'newsId' is set
      if (newsId == undefined || newsId == null) {
        throw "Missing the required parameter 'newsId' when calling deleteNews_0";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'news_id': newsId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = null;

      return this.apiClient.callApi(
        '/project/{id_or_name}/news/{news_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deletePackage operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~deletePackageCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete taret package.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~deletePackageCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deletePackage = function(idOrName, packageId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling deletePackage";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling deletePackage";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = null;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteProjectGitHook operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~deleteProjectGitHookCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete a Git repository hook
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {Integer} hookId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~deleteProjectGitHookCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteProjectGitHook = function(idOrName, repoId, hookId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling deleteProjectGitHook";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling deleteProjectGitHook";
      }

      // verify the required parameter 'hookId' is set
      if (hookId == undefined || hookId == null) {
        throw "Missing the required parameter 'hookId' when calling deleteProjectGitHook";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId,
        'hook_id': hookId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = null;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}/hooks/{hook_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteRelease operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~deleteReleaseCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete target release.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~deleteReleaseCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteRelease = function(idOrName, packageId, releaseId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling deleteRelease";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling deleteRelease";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling deleteRelease";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = null;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the deleteReleaseFile operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~deleteReleaseFileCallback
     * @param {String} error Error message, if any.
     * @param data This operation does not return a value.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Delete target file.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {Integer} fileId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~deleteReleaseFileCallback} callback The callback function, accepting three arguments: error, data, response
     */
    this.deleteReleaseFile = function(idOrName, packageId, releaseId, fileId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling deleteReleaseFile";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling deleteReleaseFile";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling deleteReleaseFile";
      }

      // verify the required parameter 'fileId' is set
      if (fileId == undefined || fileId == null) {
        throw "Missing the required parameter 'fileId' when calling deleteReleaseFile";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = null;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the disableProjectBzr operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~disableProjectBzrCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectBzr} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Disable a bzr repository (not an actual delete, just a shorthand for updating with active&#x3D;false)
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~disableProjectBzrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectBzr}
     */
    this.disableProjectBzr = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling disableProjectBzr";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling disableProjectBzr";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectBzr;

      return this.apiClient.callApi(
        '/project/{id_or_name}/bzr/{repo_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the disableProjectGit operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~disableProjectGitCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectGit} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Disable a git repository (not an actual delete, just a shorthand for updating with active&#x3D;false)
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~disableProjectGitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectGit}
     */
    this.disableProjectGit = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling disableProjectGit";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling disableProjectGit";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectGit;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the disableProjectHg operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~disableProjectHgCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectHg} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Disable a hg repository (not an actual delete, just a shorthand for updating with active&#x3D;false)
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~disableProjectHgCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectHg}
     */
    this.disableProjectHg = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling disableProjectHg";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling disableProjectHg";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectHg;

      return this.apiClient.callApi(
        '/project/{id_or_name}/hg/{repo_id}', 'DELETE',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the draftRelease operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~draftReleaseCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/Release} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get release draft in specified package. If draft is not exist, it will be created automatically.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~draftReleaseCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/Release}
     */
    this.draftRelease = function(idOrName, packageId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling draftRelease";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling draftRelease";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = Release;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/draft', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getNews operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getNewsCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/News} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get single news object.
     * @param {Integer} newsId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getNewsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/News}
     */
    this.getNews = function(newsId, callback) {
      var postBody = null;

      // verify the required parameter 'newsId' is set
      if (newsId == undefined || newsId == null) {
        throw "Missing the required parameter 'newsId' when calling getNews";
      }


      var pathParams = {
        'news_id': newsId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = News;

      return this.apiClient.callApi(
        '/news/{news_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getNews_0 operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getNews_0Callback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/News} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get single news object.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} newsId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getNews_0Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/News}
     */
    this.getNews_0 = function(idOrName, newsId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getNews_0";
      }

      // verify the required parameter 'newsId' is set
      if (newsId == undefined || newsId == null) {
        throw "Missing the required parameter 'newsId' when calling getNews_0";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'news_id': newsId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = News;

      return this.apiClient.callApi(
        '/project/{id_or_name}/news/{news_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getPackage operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getPackageCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ModelPackage} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get specified package info and release list of the package.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getPackageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ModelPackage}
     */
    this.getPackage = function(idOrName, packageId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getPackage";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling getPackage";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ModelPackage;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProject operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/Group} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get project info.
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/Group}
     */
    this.getProject = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProject";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = Group;

      return this.apiClient.callApi(
        '/project/{id_or_name}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectAdminProjectweb operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectAdminProjectwebCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectWeb} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get project homepage url
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectAdminProjectwebCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectWeb}
     */
    this.getProjectAdminProjectweb = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectAdminProjectweb";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectWeb;

      return this.apiClient.callApi(
        '/project/{id_or_name}/admin/project_web', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectBzr operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectBzrCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectBzr} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a bzr repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectBzrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectBzr}
     */
    this.getProjectBzr = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectBzr";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling getProjectBzr";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectBzr;

      return this.apiClient.callApi(
        '/project/{id_or_name}/bzr/{repo_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectGit operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectGitCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectGit} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a git repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectGitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectGit}
     */
    this.getProjectGit = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectGit";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling getProjectGit";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectGit;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectGitHook operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectGitHookCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ScmHook} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a repository hook
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {Integer} hookId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectGitHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ScmHook}
     */
    this.getProjectGitHook = function(idOrName, repoId, hookId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectGitHook";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling getProjectGitHook";
      }

      // verify the required parameter 'hookId' is set
      if (hookId == undefined || hookId == null) {
        throw "Missing the required parameter 'hookId' when calling getProjectGitHook";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId,
        'hook_id': hookId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ScmHook;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}/hooks/{hook_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectHg operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectHgCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectHg} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get a hg repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectHgCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectHg}
     */
    this.getProjectHg = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectHg";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling getProjectHg";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectHg;

      return this.apiClient.callApi(
        '/project/{id_or_name}/hg/{repo_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectProfile operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectProfileCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/GroupProfile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get project profile.
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectProfileCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/GroupProfile}
     */
    this.getProjectProfile = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectProfile";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = GroupProfile;

      return this.apiClient.callApi(
        '/project/{id_or_name}/admin/profile', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectSvn operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectSvnCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectSvn} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Subversion repository of the project
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectSvnCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectSvn}
     */
    this.getProjectSvn = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectSvn";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectSvn;

      return this.apiClient.callApi(
        '/project/{id_or_name}/svn', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getProjectTools operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getProjectToolsCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/GroupToolFlags} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get project tools info.
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~getProjectToolsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/GroupToolFlags}
     */
    this.getProjectTools = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getProjectTools";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = GroupToolFlags;

      return this.apiClient.callApi(
        '/project/{id_or_name}/admin/tools', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getRelease operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getReleaseCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/Release} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get specified release info and file list of the release.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getReleaseCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/Release}
     */
    this.getRelease = function(idOrName, packageId, releaseId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getRelease";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling getRelease";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling getRelease";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = Release;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the getReleaseFile operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~getReleaseFileCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/RelFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get single file object.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {Integer} fileId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~getReleaseFileCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/RelFile}
     */
    this.getReleaseFile = function(idOrName, packageId, releaseId, fileId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling getReleaseFile";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling getReleaseFile";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling getReleaseFile";
      }

      // verify the required parameter 'fileId' is set
      if (fileId == undefined || fileId == null) {
        throw "Missing the required parameter 'fileId' when calling getReleaseFile";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = RelFile;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listNews operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listNewsCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/News>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {Object} opts Optional parameters
     * @param {Integer} opts.groupId filter by group ID
     * @param {module:OSDN/OSDN\Api/ProjectApi~listNewsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/News>}
     */
    this.listNews = function(opts, callback) {
      opts = opts || {};
      var postBody = null;


      var pathParams = {
      };
      var queryParams = {
        'group_id': opts['groupId']
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [News];

      return this.apiClient.callApi(
        '/news', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listNews_0 operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listNews_0Callback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/News>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get news list of spscified project.
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~listNews_0Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/News>}
     */
    this.listNews_0 = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling listNews_0";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [News];

      return this.apiClient.callApi(
        '/project/{id_or_name}/news', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listPackages operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listPackagesCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/ModelPackage>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get package list of specified project.
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~listPackagesCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/ModelPackage>}
     */
    this.listPackages = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling listPackages";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [ModelPackage];

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listProjectBzr operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listProjectBzrCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/ProjectBzr>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Bazzar repository list
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~listProjectBzrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/ProjectBzr>}
     */
    this.listProjectBzr = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling listProjectBzr";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [ProjectBzr];

      return this.apiClient.callApi(
        '/project/{id_or_name}/bzr', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listProjectGit operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listProjectGitCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/ProjectGit>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get git repository list
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~listProjectGitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/ProjectGit>}
     */
    this.listProjectGit = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling listProjectGit";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [ProjectGit];

      return this.apiClient.callApi(
        '/project/{id_or_name}/git', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listProjectGitHook operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listProjectGitHookCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/ScmHook>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Git repository hook list
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {module:OSDN/OSDN\Api/ProjectApi~listProjectGitHookCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/ScmHook>}
     */
    this.listProjectGitHook = function(idOrName, repoId, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling listProjectGitHook";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling listProjectGitHook";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [ScmHook];

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}/hooks', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the listProjectHg operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~listProjectHgCallback
     * @param {String} error Error message, if any.
     * @param {Array.<module:OSDN/OSDN\Model/ProjectHg>} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Get Mercurial repository list
     * @param {String} idOrName numeric project id or project name
     * @param {module:OSDN/OSDN\Api/ProjectApi~listProjectHgCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {Array.<module:OSDN/OSDN\Model/ProjectHg>}
     */
    this.listProjectHg = function(idOrName, callback) {
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling listProjectHg";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = [ProjectHg];

      return this.apiClient.callApi(
        '/project/{id_or_name}/hg', 'GET',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateNews operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateNewsCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/News} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {Integer} newsId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.title news title
     * @param {String} opts.body news body in OSDN Wiki format.
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateNewsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/News}
     */
    this.updateNews = function(newsId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'newsId' is set
      if (newsId == undefined || newsId == null) {
        throw "Missing the required parameter 'newsId' when calling updateNews";
      }


      var pathParams = {
        'news_id': newsId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'title': opts['title'],
        'body': opts['body']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = News;

      return this.apiClient.callApi(
        '/news/{news_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateNews_0 operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateNews_0Callback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/News} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * @param {Integer} newsId 
     * @param {String} idOrName numeric project id or project name
     * @param {Object} opts Optional parameters
     * @param {String} opts.title news title
     * @param {String} opts.body news body in OSDN Wiki format.
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateNews_0Callback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/News}
     */
    this.updateNews_0 = function(newsId, idOrName, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'newsId' is set
      if (newsId == undefined || newsId == null) {
        throw "Missing the required parameter 'newsId' when calling updateNews_0";
      }

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateNews_0";
      }


      var pathParams = {
        'news_id': newsId,
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'title': opts['title'],
        'body': opts['body']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = News;

      return this.apiClient.callApi(
        '/project/{id_or_name}/news/{news_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updatePackage operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updatePackageCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ModelPackage} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update tagret package.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.name package name
     * @param {String} opts.visibility visibility status (public, hidden or private)
     * @param {module:OSDN/OSDN\Api/ProjectApi~updatePackageCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ModelPackage}
     */
    this.updatePackage = function(idOrName, packageId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updatePackage";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling updatePackage";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'name': opts['name'],
        'visibility': opts['visibility']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ModelPackage;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjectAdminProjectweb operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateProjectAdminProjectwebCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectWeb} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update project homepage url
     * @param {String} idOrName numeric project id or project name
     * @param {Object} opts Optional parameters
     * @param {String} opts.homepage Project home page full URL (should start with http:// or https://)
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateProjectAdminProjectwebCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectWeb}
     */
    this.updateProjectAdminProjectweb = function(idOrName, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateProjectAdminProjectweb";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'homepage': opts['homepage']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectWeb;

      return this.apiClient.callApi(
        '/project/{id_or_name}/admin/project_web', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjectBzr operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateProjectBzrCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectBzr} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a bzr repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.description 
     * @param {Boolean} opts.active 
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateProjectBzrCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectBzr}
     */
    this.updateProjectBzr = function(idOrName, repoId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateProjectBzr";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling updateProjectBzr";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'description': opts['description'],
        'active': opts['active']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectBzr;

      return this.apiClient.callApi(
        '/project/{id_or_name}/bzr/{repo_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjectGit operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateProjectGitCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectGit} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a git repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.description 
     * @param {Boolean} opts.mailEnabled 
     * @param {String} opts.mailRecipients 
     * @param {Boolean} opts.allowNonFastForward 
     * @param {Boolean} opts.active 
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateProjectGitCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectGit}
     */
    this.updateProjectGit = function(idOrName, repoId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateProjectGit";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling updateProjectGit";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'description': opts['description'],
        'mail_enabled': opts['mailEnabled'],
        'mail_recipients': opts['mailRecipients'],
        'allow_non_fast_forward': opts['allowNonFastForward'],
        'active': opts['active']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectGit;

      return this.apiClient.callApi(
        '/project/{id_or_name}/git/{repo_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjectHg operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateProjectHgCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/ProjectHg} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update a hg repository
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} repoId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.description 
     * @param {String} opts.mailRecipients 
     * @param {Boolean} opts.active 
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateProjectHgCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/ProjectHg}
     */
    this.updateProjectHg = function(idOrName, repoId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateProjectHg";
      }

      // verify the required parameter 'repoId' is set
      if (repoId == undefined || repoId == null) {
        throw "Missing the required parameter 'repoId' when calling updateProjectHg";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'repo_id': repoId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'description': opts['description'],
        'mail_recipients': opts['mailRecipients'],
        'active': opts['active']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = ProjectHg;

      return this.apiClient.callApi(
        '/project/{id_or_name}/hg/{repo_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjectProfile operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateProjectProfileCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/GroupProfile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update project profile.
     * @param {String} idOrName numeric project id or project name
     * @param {String} languageCode Language code for updateing display name and/or description (example en, ja, zh-TW)
     * @param {Object} opts Optional parameters
     * @param {String} opts.displayName Project display name
     * @param {String} opts.description Project description
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateProjectProfileCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/GroupProfile}
     */
    this.updateProjectProfile = function(idOrName, languageCode, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateProjectProfile";
      }

      // verify the required parameter 'languageCode' is set
      if (languageCode == undefined || languageCode == null) {
        throw "Missing the required parameter 'languageCode' when calling updateProjectProfile";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'language_code': languageCode,
        'display_name': opts['displayName'],
        'description': opts['description']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = GroupProfile;

      return this.apiClient.callApi(
        '/project/{id_or_name}/admin/profile', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateProjectTools operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateProjectToolsCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/GroupToolFlags} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update project tools info.
     * @param {String} idOrName numeric project id or project name
     * @param {Object} opts Optional parameters
     * @param {Boolean} opts.git use git flag
     * @param {Boolean} opts.svn use Subversion flag
     * @param {Boolean} opts.hg use Mercurial(Hg) flag
     * @param {Boolean} opts.bzr use Bazaar flag
     * @param {Boolean} opts.frs use File Release flag
     * @param {Boolean} opts.ticket use Ticket flag
     * @param {Boolean} opts.wiki use Wiki flag
     * @param {Boolean} opts.forum use Forum flag
     * @param {Boolean} opts.ml use Mailing List flag
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateProjectToolsCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/GroupToolFlags}
     */
    this.updateProjectTools = function(idOrName, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateProjectTools";
      }


      var pathParams = {
        'id_or_name': idOrName
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'git': opts['git'],
        'svn': opts['svn'],
        'hg': opts['hg'],
        'bzr': opts['bzr'],
        'frs': opts['frs'],
        'ticket': opts['ticket'],
        'wiki': opts['wiki'],
        'forum': opts['forum'],
        'ml': opts['ml']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = GroupToolFlags;

      return this.apiClient.callApi(
        '/project/{id_or_name}/admin/tools', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateRelease operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateReleaseCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/Release} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Update target release. (Note: If you update draft release, the release will be public automatically.) 
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.visibility visibility status (public, hidden or private)
     * @param {String} opts.name Release name
     * @param {Date} opts.time Release datetime. If you set future time, the release hide until specified time.
     * @param {Integer} opts.moveToPackageId If this parameter is specified, the release move to another package.
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateReleaseCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/Release}
     */
    this.updateRelease = function(idOrName, packageId, releaseId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateRelease";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling updateRelease";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling updateRelease";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'visibility': opts['visibility'],
        'name': opts['name'],
        'time': opts['time'],
        'move_to_package_id': opts['moveToPackageId']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = Release;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }

    /**
     * Callback function to receive the result of the updateReleaseFile operation.
     * @callback module:OSDN/OSDN\Api/ProjectApi~updateReleaseFileCallback
     * @param {String} error Error message, if any.
     * @param {module:OSDN/OSDN\Model/RelFile} data The data returned by the service call.
     * @param {String} response The complete HTTP response.
     */

    /**
     * Change visibility of target file.
     * @param {String} idOrName numeric project id or project name
     * @param {Integer} packageId 
     * @param {Integer} releaseId 
     * @param {Integer} fileId 
     * @param {Object} opts Optional parameters
     * @param {String} opts.visibility visibility status (public, hidden or private)
     * @param {module:OSDN/OSDN\Api/ProjectApi~updateReleaseFileCallback} callback The callback function, accepting three arguments: error, data, response
     * data is of type: {module:OSDN/OSDN\Model/RelFile}
     */
    this.updateReleaseFile = function(idOrName, packageId, releaseId, fileId, opts, callback) {
      opts = opts || {};
      var postBody = null;

      // verify the required parameter 'idOrName' is set
      if (idOrName == undefined || idOrName == null) {
        throw "Missing the required parameter 'idOrName' when calling updateReleaseFile";
      }

      // verify the required parameter 'packageId' is set
      if (packageId == undefined || packageId == null) {
        throw "Missing the required parameter 'packageId' when calling updateReleaseFile";
      }

      // verify the required parameter 'releaseId' is set
      if (releaseId == undefined || releaseId == null) {
        throw "Missing the required parameter 'releaseId' when calling updateReleaseFile";
      }

      // verify the required parameter 'fileId' is set
      if (fileId == undefined || fileId == null) {
        throw "Missing the required parameter 'fileId' when calling updateReleaseFile";
      }


      var pathParams = {
        'id_or_name': idOrName,
        'package_id': packageId,
        'release_id': releaseId,
        'file_id': fileId
      };
      var queryParams = {
      };
      var headerParams = {
      };
      var formParams = {
        'visibility': opts['visibility']
      };

      var authNames = ['oauth2-code', 'oauth2-implicit'];
      var contentTypes = ['application/x-www-form-urlencoded'];
      var accepts = [];
      var returnType = RelFile;

      return this.apiClient.callApi(
        '/project/{id_or_name}/frs/{package_id}/{release_id}/{file_id}', 'PATCH',
        pathParams, queryParams, headerParams, formParams, postBody,
        authNames, contentTypes, accepts, returnType, callback
      );
    }
  };

  return exports;
}));
